'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var Pagination = function (_Component) {
  inherits(Pagination, _Component);

  function Pagination() {
    var _ref;

    var _temp, _this, _ret;

    classCallCheck(this, Pagination);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = Pagination.__proto__ || Object.getPrototypeOf(Pagination)).call.apply(_ref, [this].concat(args))), _this), _this.pagination = function (current, last, handlePageChange) {

      var delta = 2,
          left = current - delta,
          right = current + delta + 1,
          range = [],
          rangeWithDots = [],
          l = void 0;

      range.push(1);
      for (var i = current - delta; i <= current + delta; i++) {
        if (i >= left && i < right && i < last && i > 1) {
          range.push(i);
        }
      }
      range.push(last);

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = range[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _i = _step.value;

          if (l) {
            if (_i - l === 2) {
              rangeWithDots.push(l + 1);
            } else if (_i - l !== 1) {
              rangeWithDots.push('...');
            }
          }
          rangeWithDots.push(_i);
          l = _i;
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      var pages = [];

      var _loop = function _loop(_i2) {
        pages.push(React__default.createElement(
          'li',
          { key: _i2, className: "page-item " + (rangeWithDots[_i2] === current ? "active" : rangeWithDots[_i2] === "..." ? "disabled" : "") },
          React__default.createElement(
            'span',
            { onClick: function onClick() {
                handlePageChange(rangeWithDots[_i2]);
              }, style: { cursor: 'pointer' }, className: 'page-link' },
            rangeWithDots[_i2]
          )
        ));
      };

      for (var _i2 = 0; _i2 < rangeWithDots.length; _i2++) {
        _loop(_i2);
      }
      return pages;
    }, _this.position = function () {
      var position = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "left";

      switch (position) {
        case 'center':
          return 'justify-content-center';
        case 'right':
          return 'justify-content-end';
        default:
          return '';
      }
    }, _temp), possibleConstructorReturn(_this, _ret);
  }

  createClass(Pagination, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          current_page = _props.current_page,
          last_page = _props.last_page,
          position = _props.position,
          handlePageChange = _props.handlePageChange;


      return React__default.createElement(
        'nav',
        { 'aria-label': 'Page navigation example' },
        React__default.createElement(
          'ul',
          { className: "pagination " + this.position(position) },
          this.pagination(current_page, last_page, handlePageChange)
        )
      );
    }
  }]);
  return Pagination;
}(React.Component);

module.exports = Pagination;
//# sourceMappingURL=index.js.map
